--[[    Vacuous - The generic top-down shooter
    Copyright (C) 2013  Thomas Harrison

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see [http://www.gnu.org/licenses/].
]]

function love.load()
	Collider = require "hardoncollider"
	require "levels"
    HC = Collider(100)
	ship = {
		g = {{15,0},
		{12,6},
		{11,14},
		{1,18},
		{13,20},
		{12,22},
		{19,22},
		{18,20},
		{30,18},
		{20,14},
		{19,6},
		{16,0}, -- 12

		{15,5},
		{14,9},
		{17,9},
		{16,5}, -- 16

		{13,22},
		{15,27},
		{16,28},
		{18,22}
			},
		xpos = 134,
		ypos = 484,
		powerup = {},
		movespeed = 160, -- 160 px/second
		bulletspeed = -200, -- 200 px/second
		firingspeed = .40, --that is, 1/num attacks per second
		bulletfired = 2, -- number of bullets fired
		bulletsize = 2 -- radius of bullets created
		}
	ship.col = HC:addPolygon(
			ship.g[1][1], ship.g[1][2],
			ship.g[2][1], ship.g[2][2],
			ship.g[3][1], ship.g[3][2],
			ship.g[4][1], ship.g[4][2],
			ship.g[5][1], ship.g[5][2],
			ship.g[6][1], ship.g[6][2],
			ship.g[7][1], ship.g[7][2],
			ship.g[8][1], ship.g[8][2],
			ship.g[9][1], ship.g[9][2],
			ship.g[10][1], ship.g[10][2],
			ship.g[11][1], ship.g[11][2],
			ship.g[12][1], ship.g[12][2])
	ship.col:moveTo(ship.xpos + 15.5, ship.ypos + 12)

	jet = 2
	stars = {}
	for num = 1, math.random(68, 76) do
		stars[#stars + 1] = {math.random(0,299) + .5, math.random(0,549), math.random(20,50)}
	end
	bullets = {}
	enemy = {bullets = {}}
	score = 0
	seconds = 0
	waves = 0
	bombs = 5
	lives = 10
	respawn = 0
	chance = 100
	timer = 0
	maxfps = 60
	gamestate = "paused"
	bigfont = love.graphics.newFont(30)
	medfont = love.graphics.newFont(20)
	norfont = love.graphics.newFont(12)
	sound = {
		pshoot = love.sound.newSoundData("sound/pshoot.ogg"),
		enemyexplode = love.sound.newSoundData("sound/explode.ogg"),
		playerexplode = love.sound.newSoundData("sound/playerexplode.ogg"),
		bigexplode = love.sound.newSoundData("sound/bigexplode.ogg"),
		shield = love.sound.newSoundData("sound/shield.ogg"),
		permpowerup = love.sound.newSoundData("sound/permpowerup.ogg"),
		smallpowerup = love.sound.newSoundData("sound/smallpowerup.ogg"),
		bosshit = love.sound.newSoundData("sound/bosshit.ogg"),
		bossexplode = love.sound.newSoundData("sound/bossexplode.ogg")
		}

	powerups = {
		{graphic = function(x,y)
				love.graphics.setColor(0,134,75)
				love.graphics.polygon("line",
					x + 7,  y + 6,
					x + 6,  y + 10,
					x + 3,  y + 11,
					x + 6,  y + 12,
					x + 9,  y + 12,
					x + 12, y + 11,
					x + 9,  y + 10,
					x + 8,  y + 6)
				love.graphics.polygon("line",
					x + 5, y + 3,
					x + 6, y + 3,
					x + 6, y + 4,
					x + 5, y + 4)
				love.graphics.polygon("line",
					x + 2, y + 5,
					x + 3, y + 5,
					x + 3, y + 6,
					x + 2, y + 6)
				love.graphics.polygon("line",
					x + 9, y + 3,
					x + 10, y + 3,
					x + 10, y + 4,
					x + 9, y + 4)
				love.graphics.polygon("line",
					x + 12, y + 5,
					x + 13, y + 5,
					x + 13, y + 6,
					x + 12, y + 6)
			end,
			effect = function()
				ship.bulletfired = ship.bulletfired + 2
				love.audio.newSource(sound.permpowerup):play()
			end,
			reverse = function()
				ship.bulletfired = ship.bulletfired - 2
			end},
		{graphic = function(x,y)
				love.graphics.setColor(0,134,75)
				love.graphics.polygon("line",
					x + 7,  y + 8,
					x + 6,  y + 12,
					x + 3,  y + 13,
					x + 6,  y + 14,
					x + 9,  y + 14,
					x + 12, y + 13,
					x + 9,  y + 12,
					x + 8,  y + 8)
				love.graphics.polygon("line",
					x + 4, y + 1,
					x + 5, y + 1,
					x + 5, y + 2,
					x + 4, y + 2)
				love.graphics.polygon("line",
					x + 10, y + 1,
					x + 11, y + 1,
					x + 11, y + 2,
					x + 10, y + 2)
				love.graphics.polygon("line",
					x + 4, y + 4,
					x + 5, y + 4,
					x + 5, y + 5,
					x + 4, y + 5)
				love.graphics.polygon("line",
					x + 10, y + 4,
					x + 11, y + 4,
					x + 11, y + 5,
					x + 10, y + 5)
				love.graphics.polygon("line",
					x + 4, y + 7,
					x + 5, y + 7,
					x + 5, y + 8,
					x + 4, y + 8)
				love.graphics.polygon("line",
					x + 10, y + 7,
					x + 11, y + 7,
					x + 11, y + 8,
					x + 10, y + 8)
			end,
			effect = function()
				ship.firingspeed = ship.firingspeed - .1
				love.audio.newSource(sound.permpowerup):play()
			end,
			reverse = function()
				ship.firingspeed = ship.firingspeed + .1
			end},
		{graphic = function(x,y)
				love.graphics.setColor(0,134,75)
				love.graphics.polygon("line",
					x + 7,  y + 1,
					x + 6,  y + 5,
					x + 3,  y + 6,
					x + 6,  y + 7,
					x + 9,  y + 7,
					x + 12, y + 6,
					x + 9,  y + 5,
					x + 8,  y + 1)
				love.graphics.setColor(186,19,26)
				love.graphics.line(
					x + 7, y + 8,
					x + 7, y + 15)
				love.graphics.line(
					x + 8, y + 8,
					x + 8, y + 15)
			end,
			effect = function()
				ship.movespeed = ship.movespeed + 50
				ship.bulletspeed = ship.bulletspeed - 60
				love.audio.newSource(sound.permpowerup):play()
			end,
			reverse = function()
				ship.movespeed = ship.movespeed - 50
				ship.bulletspeed = ship.bulletspeed + 60
			end},
		{graphic = function(x,y)
				love.graphics.setColor(0,134,75)
				love.graphics.polygon("line",
					x + 7,  y + 6,
					x + 6,  y + 10,
					x + 3,  y + 11,
					x + 6,  y + 12,
					x + 9,  y + 12,
					x + 12, y + 11,
					x + 9,  y + 10,
					x + 8,  y + 6)
				love.graphics.circle("line", x+3, y+5, 3, 8)
				love.graphics.circle("line", x+11, y+5, 3, 8)
			end,
			effect = function()
				ship.bulletsize = ship.bulletsize + 1
				love.audio.newSource(sound.permpowerup):play()
			end,
			reverse = function()
				ship.bulletsize = ship.bulletsize - 1
			end},
		{graphic = function(x,y)
				love.graphics.setColor(0,134,75)
				love.graphics.polygon("line",
					x + 4,  y + 6,
					x + 2,  y + 10,
					x + 4,  y + 14,
					x + 9,  y + 14,
					x + 11, y + 10,
					x + 9, y + 6)
				love.graphics.line(
					x + 9, y + 6,
					x + 11, y + 4,
					x + 11, y + 2,
					x + 9, y + 1)
			end,
			effect = function()
				bombs = bombs + 2
				love.audio.newSource(sound.smallpowerup):play()
			end,
			temporary = true},
		ingame = {}
		}

	if love.filesystem.exists("config") then
		unserial(love.filesystem.read("config"))
	else
		controller = {
			left = 16,
			right = 14,
			up = 13,
			down = 15,
			shoot = 2,
			bomb = 3,
			pause = 10,
			}
	end

	controlsets = {
		"left",
		"right",
		"up",
		"down",
		"shoot",
		"bomb",
		"pause"}

--[[
			for num = 1, 16 do
				local x = math.random(0,280)
				local y = 0
				enemy[#enemy + 1] = {
					HC:addPolygon(x + 15,y+12,x+13,y+15,x+12,y+17,x+17,y+14,x+18,y+10,x+16,y+5,x+11,y+2,x+8,y+2,x+3,y+5,x+1,y+10,x+2,y+14,x+7,y+17,x+6,y+15,x+4,y+12,x+6,y+10,x+8,y+13,x+11,y+13,x+13,y+10),
					yspeed = math.random(30,40), xspeed = 0, shottimer = math.random(1,20) / 10}
				enemy[#enemy][1]:moveTo(x,y)
			end

			for num = 1, 16 do
				local x = 20
				local y = -27*num
				enemy[#enemy + 1] = {
					HC:addPolygon(x+1,y+1,x+5,y+12,x+3,y+18,x+8,y+14,x+9,y+10,x+10,y+10,x+11,y+14,x+16,y+18,x+14,y+12,x+18,y+1,x+11,y+4,x+8,y+4),
					yspeed = 70, xspeed = 0, shottimer = math.random(1,20)/10}
				enemy[#enemy][1]:moveTo(x,y)
			end

			for num = 1, 16 do
			local x = 260
			local y = -27*num
				enemy[#enemy + 1] = {
					HC:addPolygon(x+1,y+1,x+5,y+12,x+3,y+18,x+8,y+14,x+9,y+10,x+10,y+10,x+11,y+14,x+16,y+18,x+14,y+12,x+18,y+1,x+11,y+4,x+8,y+4),
					yspeed = 70, xspeed = 0, shottimer = math.random(1,20)/10}
			end

			for num = 1, 16 do
				enemy[#enemy + 1] = {HC:addRectangle(math.random(0,280), 0, 20,20),
					yspeed = math.random(60,100), xspeed = math.random(-50,50)}
			end

			for num = 1, 8 do
				enemy[#enemy + 1] = {HC:addRectangle(40 + 25 * num, -10*num, 20,20),
					yspeed = 50, xspeed = 70, shottimer = math.random(1,20) / 10}
				enemy[#enemy + 1] = {HC:addRectangle(240 - 25 * num, -10*num, 20,20),
					yspeed = 50, xspeed = -70, shottimer = math.random(1,20) / 10}
			end

			powerups.ingame[#powerups.ingame + 1] = {HC:addRectangle(142,0,15,15), kind = powerups[math.random(1, #powerups)]}
	]]



end

function serial(tabl)
	data = "controller = {"
	for key, num in pairs(tabl) do
		data = data.."[\""..key.."\"] = "..num..", "
	end
	data = data.."}"
	return data
end

function unserial(strin)
	loadstring(strin)()
end

function love.keyreleased(key,unicode)
	if gamestate == "ingame" then
		if key == "o" and delay ~= true then
			timer = 0
		elseif key == "escape" then
			gamestate = "paused"
		end
	elseif gamestate == "paused" then
		if key == "escape" then
			gamestate = "ingame"
		elseif key == "c" then
			gamestate = "controllersetup"
			setup = {}
		end
	elseif gamestate == "controllersetup" then
		if key == "escape" then
			gamestate = "paused"
			setup = nil
		elseif key == " " then
			loadstring("setup["..(#setup + 1).."] = controller."..controlsets[#setup + 1])()
			if #setup == 7 then
				gamestate = "paused"
				for num = 1,7 do
					loadstring("controller."..controlsets[num].." = setup["..num.."]")()
				end
				setup = nil
				love.filesystem.write("config", serial(controller))
			end
		end
	end
end

function love.joystickreleased(joystick, key)
	if gamestate == "ingame" and love.joystick.isOpen(1) then
		if key == controller.shoot and delay ~= true then
			timer = 0
		elseif key == controller.pause then
			gamestate = "paused"
		end
	elseif gamestate == "paused" then
		if key == controller.pause then
			gamestate = "ingame"
		end
	elseif gamestate == "controllersetup" then
		setup[#setup + 1] = key
		if #setup == 7 then
			gamestate = "paused"
			for num = 1,7 do
				loadstring("controller."..controlsets[num].." = setup["..num.."]")()
			end
			setup = nil
			love.filesystem.write("config", serial(controller))
		end
	end
end

function love.keypressed(key,unicode)
	if gamestate == "ingame" then
		if key == "o" then
			delay = true
		end
		if key == "p" and bombs ~= 0 and fail ~= true and respawn == 0 and bombcd == nil then
			bombs = bombs - 1
			love.audio.newSource(sound.bigexplode):play()
			for num = #enemy, 1,-1 do
				HC:remove(enemy[num][1])
				table.remove(enemy, num)
				score = score + 10
			end
			for num = #enemy.bullets, 1,-1 do
				HC:remove(enemy.bullets[num][1])
				table.remove(enemy.bullets, num)
			end
			if boss	~= nil then
				boss.health = boss.health - 25
				for num = #boss.bullets, 1,-1 do
					HC:remove(boss.bullets[num][1])
					table.remove(boss.bullets, num)
				end
				if boss.health <= 0 then
					boss = nil
					seconds = 0
					bossexplode = 4
					explodes = {}
					score = score + 500
				end
			end
			bombcd = 3
			local x,y = ship.col:center()
			bombexplode = {x,y,4}
		end
	end
end

function love.joystickpressed(joystick, key)
	if gamestate == "ingame" and love.joystick.isOpen(1) then
		if key == controller.shoot then
			delay = true
		end
		if key == controller.bomb and bombs ~= 0 and fail ~= true and respawn == 0 and bombcd == nil then
			bombs = bombs - 1
			love.audio.newSource(sound.bigexplode):play()
			for num = #enemy, 1,-1 do
				HC:remove(enemy[num][1])
				table.remove(enemy, num)
				score = score + 10
			end
			for num = #enemy.bullets, 1,-1 do
				HC:remove(enemy.bullets[num][1])
				table.remove(enemy.bullets, num)
			end
			if boss	~= nil then
				boss.health = boss.health - 25
				for num = #boss.bullets, 1,-1 do
					HC:remove(boss.bullets[num][1])
					table.remove(boss.bullets, num)
				end
				if boss.health <= 0 then
					boss = nil
					seconds = 0
					bossexplode = 4
					explodes = {}
					score = score + 500
				end
			end
			bombcd = 3
			local x,y = ship.col:center()
			bombexplode = {x,y,4}
		end
	end
end

function love.update(dt)
	collectgarbage("collect", 256)
	if gamestate == "ingame" then
		local temp = love.joystick.getHat(1, 1)
		local axis1,axis2 = love.joystick.getAxes(1)
		if axis1 == nil or axis2 == nil then
			axis1, axis2 = 0,0
		end
		if love.keyboard.isDown("w", "up") or
				love.joystick.isDown(1, controller.up) or
				temp == "u" or temp == "lu" or temp == "ru" or
				axis2 < -.25 then
			if ship.ypos - ship.movespeed * dt > 0 then
				ship.ypos = ship.ypos - ship.movespeed * dt
			else ship.ypos = 0
			end
		elseif love.keyboard.isDown("s", "down") or
				love.joystick.isDown(1, controller.down) or
				temp == "d" or temp == "rd" or temp == "ld" or
				axis2 > .25 then
			if ship.ypos + ship.movespeed * dt < 522 then
				ship.ypos = ship.ypos + ship.movespeed * dt
			else ship.ypos = 522
			end
		end
		if love.keyboard.isDown("a", "left") or
				love.joystick.isDown(1, controller.left) or
				temp == "l" or temp == "ld" or temp == "lu" or
				axis1 < -.25 then
			if ship.xpos - ship.movespeed * dt > 0 then
				ship.xpos = ship.xpos - ship.movespeed * dt
			else ship.xpos = 0
			end
		elseif love.keyboard.isDown("d", "right") or
				love.joystick.isDown(1, controller.right) or
				temp == "r" or temp == "ru" or temp == "rd" or
				axis1 > .25 then
			if ship.xpos + ship.movespeed * dt < 268 then
				ship.xpos = ship.xpos + ship.movespeed * dt
			else ship.xpos = 268
			end
		end

		ship.col:moveTo(ship.xpos + 15.5, ship.ypos + 12)

		for num = #bullets, 1, -1 do
			bullets[num][1]:move(bullets[num].xspeed * dt,bullets[num].yspeed*dt)
			local x,y = bullets[num][1]:center()
			if y < 0 then
				HC:remove(bullets[num][1])
				table.remove(bullets, num)
			end
		end

		if bombcd ~= nil then
			bombcd = bombcd - dt
			if bombcd <= 0 then
				bombcd = nil
			end
		end

		if (love.keyboard.isDown("o") or love.joystick.isDown(1,controller.shoot)) and fail ~= true and respawn == 0 then
			if timer == 0 then
				local x, y = ship.col:center()
				if ship.bulletfired >= 2 then
					bullets[#bullets + 1] = {HC:addCircle(x-5,y-10,ship.bulletsize), xspeed = 0, yspeed = ship.bulletspeed}
					bullets[#bullets + 1] = {HC:addCircle(x+5,y-10,ship.bulletsize), xspeed = 0, yspeed = ship.bulletspeed}
				end
				if ship.bulletfired >= 4 then
					bullets[#bullets + 1] = {HC:addCircle(x-8,y-9,ship.bulletsize), xspeed = ship.bulletspeed * .02, yspeed = ship.bulletspeed * .99}
					bullets[#bullets + 1] = {HC:addCircle(x+8,y-9,ship.bulletsize), xspeed = ship.bulletspeed * -.02, yspeed = ship.bulletspeed * .99}
				end
				if ship.bulletfired >= 6 then
					bullets[#bullets + 1] = {HC:addCircle(x-11,y-8,ship.bulletsize), xspeed = ship.bulletspeed * .05, yspeed = ship.bulletspeed * .96}
					bullets[#bullets + 1] = {HC:addCircle(x+11,y-8,ship.bulletsize), xspeed = ship.bulletspeed * -.05, yspeed = ship.bulletspeed * .96}
				end
				if ship.bulletfired >= 8 then
					bullets[#bullets + 1] = {HC:addCircle(x-14,y-7,ship.bulletsize), xspeed = ship.bulletspeed * .09, yspeed = ship.bulletspeed * .91}
					bullets[#bullets + 1] = {HC:addCircle(x+14,y-7,ship.bulletsize), xspeed = ship.bulletspeed * -.09, yspeed = ship.bulletspeed * .91}
				end
				love.audio.newSource(sound.pshoot):play()
			end
			timer = timer + dt
			if timer > ship.firingspeed then
				timer = 0
				delay = false
			end
		end

		seconds = seconds + dt

		if seconds >= 6 and fail ~= true then
			enemyspawn()
		end

		for num = #powerups.ingame , 1 ,-1 do
			powerups.ingame[num][1]:move(0,40*dt)
			if powerups.ingame[num][1]:collidesWith(ship.col) and powerups.ingame[num].kind.temporary == true and fail ~= true and respawn == 0 then
				powerups.ingame[num].kind.effect()
				HC:remove(powerups.ingame[num][1])
				table.remove(powerups.ingame, num)
			elseif powerups.ingame[num][1]:collidesWith(ship.col) and #ship.powerup ~= 3 and fail ~= true and respawn == 0 then
				ship.powerup[#ship.powerup + 1] = powerups.ingame[num].kind
				ship.powerup[#ship.powerup].effect()
				HC:remove(powerups.ingame[num][1])
				table.remove(powerups.ingame, num)
			elseif powerups.ingame[num][1]:collidesWith(ship.col) and #ship.powerup == 3 and fail ~= true and respawn == 0 then
				ship.powerup[1].reverse()
				table.remove(ship.powerup, 1)
				ship.powerup[3] = powerups.ingame[num].kind
				ship.powerup[3].effect()
				HC:remove(powerups.ingame[num][1])
				table.remove(powerups.ingame, num)
			end
		end

		for num = #enemy.bullets, 1, -1 do
			-- player collision
			if enemy.bullets[num][1]:collidesWith(ship.col) and fail ~= true and respawn == 0 then
				fail = true
				love.audio.newSource(sound.playerexplode):play()
				HC:remove(enemy.bullets[num][1])
				table.remove(enemy.bullets, num)
			end
			-- misc
			if enemy.bullets[num] ~= nil then
				enemy.bullets[num][1]:move(enemy.bullets[num].xspeed * dt,enemy.bullets[num].yspeed * dt)
				local x,y = enemy.bullets[num][1]:center()
				if y > 554 then
					HC:remove(enemy.bullets[num][1])
					table.remove(enemy.bullets, num)
				elseif y < 0 then
					HC:remove(enemy.bullets[num][1])
					table.remove(enemy.bullets, num)
				elseif x <= 0 then
					HC:remove(enemy.bullets[num][1])
					table.remove(enemy.bullets, num)
				elseif x >= 300 then
					HC:remove(enemy.bullets[num][1])
					table.remove(enemy.bullets, num)
				end
			end
		end

		for num = #enemy, 1, -1 do
			--bullets
			if enemy[num].shottimer ~= nil and respawn == 0 and fail ~= true then
				enemy[num].shottimer = enemy[num].shottimer + dt
				if enemy[num].shottimer >= 2 then
					enemy[num].shottimer = 0
					local x,y = enemy[num][1]:center()
					local x2,y2 = ship.col:center()
					local xf = x2-x + math.random(-25,25)
					local yf = y2-y + math.random(-25,25)
					if x2 < x and y2 < y then
						enemy.bullets[#enemy.bullets + 1] = {HC:addCircle(x,y,2), xspeed = ((xf*180)/(xf+yf)) * - 1, yspeed = ((yf*180)/(xf+yf)) * - 1}
					elseif x2 > x and y2 > y then
						enemy.bullets[#enemy.bullets + 1] = {HC:addCircle(x,y,2), xspeed = ((xf*180)/(xf+yf)), yspeed = ((yf*180)/(xf+yf))}
					elseif x2 < x and y2 > y then
						enemy.bullets[#enemy.bullets + 1] = {HC:addCircle(x,y,2), xspeed = ((xf*180)/(xf-yf)) * - 1, yspeed = ((yf*180)/(xf-yf)) * - 1}
					elseif x2 > x and y2 < y then
						enemy.bullets[#enemy.bullets + 1] = {HC:addCircle(x,y,2), xspeed = ((xf*180)/(xf-yf)), yspeed = ((yf*180)/(xf-yf))}
					end
				end
			end
			-- enemy movement n shit
			enemy[num][1]:move(enemy[num].xspeed * dt,enemy[num].yspeed * dt)
			local x,y = enemy[num][1]:center()
			if x <= 10 then
				enemy[num].xspeed = enemy[num].xspeed * -1
				enemy[num][1]:moveTo(11,y)
			elseif x >= 290 then
				enemy[num].xspeed = enemy[num].xspeed * -1
				enemy[num][1]:moveTo(289,y)
			end
			if y > 610 and enemy[num].yspeed == math.abs(enemy[num].yspeed) then
				HC:remove(enemy[num][1])
				table.remove(enemy, num)
			elseif y < 0 and enemy[num].yspeed ~= math.abs(enemy[num].yspeed) then
				HC:remove(enemy[num][1])
				table.remove(enemy, num)
			end

			if enemy[num] ~= nil then
					-- enemy death
				if enemy[num][1]:collidesWith(ship.col) and fail ~= true and respawn == 0 then
					fail = true
					love.audio.newSource(sound.playerexplode):play()
					HC:remove(enemy[num][1])
					table.remove(enemy, num)
				end
			end
			if enemy[num] ~= nil then
				for numt = #bullets, 1, -1 do
					if enemy[num] ~= nil then
						if enemy[num][1]:collidesWith(bullets[numt][1]) then
							HC:remove(enemy[num][1])
							table.remove(enemy, num)
							HC:remove(bullets[numt][1])
							table.remove(bullets, numt)
							score = score + 10
							love.audio.newSource(sound.enemyexplode):play()
						end
					end
				end
			end
		end

		if boss ~= nil then
			boss.timer = boss.timer + dt
			if boss.timer2 ~= nil then
				boss.timer2 = boss.timer2 + dt
			end
			boss.phasetimer = boss.phasetimer + dt
			if boss.phasetimer >= 1 then
				boss.phasetimer = 0
				boss.phasenum = boss.phasenum + 1
				if boss.phasenum >= 11 then
					boss.phasenum = 1
				end
				boss.activephase = boss.phase[boss.phasenum]
			end
			boss.activephase(dt)
			if boss.xspeed ~= nil then
				boss.col:move(boss.xspeed*dt,0)
				local x,y = boss.col:center()
				if x-56 <= 0 then
					boss.xspeed = boss.xspeed * -1
				elseif x+55 >= 300 then
					boss.xspeed = boss.xspeed * -1
				end
			end
			if boss.col:collidesWith(ship.col) and fail ~= true and respawn == 0 then
				fail = true
				love.audio.newSource(sound.playerexplode):play()
			end
			for num = #boss.bullets, 1, -1 do
				boss.bullets[num][1]:move(boss.bullets[num].xspeed*dt,boss.bullets[num].yspeed*dt)
				local x,y = boss.bullets[num][1]:center()
				if boss.bullets[num][1]:collidesWith(ship.col) and fail ~= true and respawn == 0 then
					fail = true
					love.audio.newSource(sound.playerexplode):play()
					HC:remove(boss.bullets[num][1])
					table.remove(boss.bullets, num)
				elseif x <= 0 then
					HC:remove(boss.bullets[num][1])
					table.remove(boss.bullets, num)
				elseif x >= 300 then
					HC:remove(boss.bullets[num][1])
					table.remove(boss.bullets, num)
				elseif y >= 600 then
					HC:remove(boss.bullets[num][1])
					table.remove(boss.bullets, num)
				elseif y <= 0 then
					HC:remove(boss.bullets[num][1])
					table.remove(boss.bullets, num)
				end
			end
			for num = #bullets, 1 ,-1 do
				if boss.col:collidesWith(bullets[num][1]) then
					boss.health = boss.health - (ship.bulletsize -1/(ship.bulletfired))
					HC:remove(bullets[num][1])
					table.remove(bullets, num)
					love.audio.newSource(sound.bosshit):play()
					if boss.health <= 0 then
						boss = nil
						seconds = 0
						bossexplode = 4
						explodes = {}
						score = score + 500
						break
					end
				end
			end
		end

		jet = jet + 2
		if jet == 4 then
			jet = 0
		end

		if fail == true and lives ~= 0 then
			respawn = 5
			lives = lives - 1
			fail = false
			if #ship.powerup == 3 then
				for num = 3,2, -1 do
					ship.powerup[num].reverse()
					table.remove(ship.powerup, num)
				end
			elseif #ship.powerup == 2 then
				ship.powerup[2].reverse()
				table.remove(ship.powerup, 2)
			elseif #ship.powerup == 1 then
				ship.powerup[1].reverse()
				table.remove(ship.powerup, 1)
			end
		end

		if respawn ~= 0 then
			respawn = respawn - dt
			if respawn <= 0 then
				ship.xpos = 134
				ship.ypos = 500
				ship.col:moveTo(ship.xpos + 15.5, ship.ypos + 12)
				respawn = 0
				ship.shield = HC:addCircle(ship.xpos + 15.5, ship.ypos + 12, 24)
				love.audio.newSource(sound.shield):play()
				ship.shieldtimer = 5
			end
		end

		if ship.shieldtimer ~= nil then
			ship.shieldtimer = ship.shieldtimer - dt
			ship.shield:moveTo(ship.xpos + 15.5, ship.ypos + 12)
			for num = #enemy, 1, -1 do
				if enemy[num][1]:collidesWith(ship.shield) and fail ~= true and respawn == 0 then
					HC:remove(enemy[num][1])
					table.remove(enemy, num)
					score = score + 10
					love.audio.newSource(sound.enemyexplode):play()
				end
			end
			for num = #enemy.bullets, 1, -1 do
				if enemy.bullets[num][1]:collidesWith(ship.shield) and fail ~= true and respawn == 0 then
					HC:remove(enemy.bullets[num][1])
					table.remove(enemy.bullets, num)
				end
			end
			if boss ~= nil then
				for num = #boss.bullets, 1, -1 do
					if boss.bullets[num][1]:collidesWith(ship.shield) and fail ~= true and respawn == 0 then
						HC:remove(boss.bullets[num][1])
						table.remove(boss.bullets, num)
					end
				end
			end
			if ship.shieldtimer <= 0 then
				ship.shieldtimer = nil
				ship.shield = nil
			end
		end

		if 1 == math.random(1,10) then
			stars[#stars + 1] = {math.random(0,299) + .5, 0, math.random(20,50)}
		end
		for num = #stars, 1 ,-1 do
			stars[num][2] = stars[num][2] + stars[num][3] * dt
			if stars[num][2] >= 554 then
				table.remove(stars, num)
			end
		end

		if bossexplode ~= nil then
			if 1 >= math.random(1,15) then
				explodes[#explodes + 1] = {math.random(75,225),math.random(25,150),1}
				love.audio.newSource(sound.bossexplode):play()
			end
			for num = #explodes, 1 ,-1 do
				explodes[num][3] = explodes[num][3] + 20 * dt
				if explodes[num][3] >= 25 then
					table.remove(explodes, num)
				end
			end

			bossexplode = bossexplode - dt
			if bossexplode <= 0 then
				bossexplode = nil
				explodes = nil
			end
		end

		if bombexplode ~= nil then
			bombexplode[3] = bombexplode[3] + 70*dt
			if bombexplode[3] >= 50 then
				bombexplode = nil
			end
		end
	end
end

function enemyspawn()
	seconds = 0

	if win ~= true then
		if boss == nil then
			waves = waves + 1
			level[waves]()
		end
	elseif boss == nil then
		waves = waves + 1
		if math.ceil(waves/10) == waves/10 then
			bosses()
		else
			chance = math.random(1,100)
			if chance <= 25 then
				for num = 1, 16 do
					local x = math.random(0,280)
					local y = 0
					enemy[#enemy + 1] = {
					HC:addPolygon(
							x + 15, y + 12,
							x + 13, y + 15,
							x + 12, y + 17,
							x + 17, y + 14,
							x + 18, y + 10,
							x + 16, y + 5,
							x + 11, y + 2,
							x +  8, y + 2,
							x +  3, y + 5,
							x +  1, y + 10,
							x +  2, y + 14,
							x +  7, y + 17,
							x +  6, y + 15,
							x +  4, y + 12,
							x +  6, y + 10,
							x +  8, y + 13,
							x + 11, y + 13,
							x + 13, y + 10),
					yspeed = math.random(30,40), xspeed = 0, shottimer = math.random(1,20) / 10}
					enemy[#enemy][1]:moveTo(x,y)
				end
			elseif chance > 25 and chance <= 37 then
				for num = 1, 16 do
					local x = 20
					local y = -27*num
					enemy[#enemy + 1] = {HC:addPolygon(
							x + 1  , y + 1,
							x + 5  , y + 12,
							x + 3  , y + 18,
							x + 8  , y + 14,
							x + 9  , y + 10,
							x + 10 , y + 10,
							x + 11 , y + 14,
							x + 16 , y + 18,
							x + 14 , y + 12,
							x + 18 , y + 1,
							x + 11 , y + 4,
							x + 8  , y + 4),
					yspeed = 70, xspeed = 0, shottimer = math.random(1,20)/10}
					enemy[#enemy][1]:moveTo(x,y)
				end
			elseif chance > 37 and chance <= 49 then
				for num = 1, 16 do
				local x = 260
				local y = -27*num
					enemy[#enemy + 1] = {HC:addPolygon(
							x + 1  , y + 1,
							x + 5  , y + 12,
							x + 3  , y + 18,
							x + 8  , y + 14,
							x + 9  , y + 10,
							x + 10 , y + 10,
							x + 11 , y + 14,
							x + 16 , y + 18,
							x + 14 , y + 12,
							x + 18 , y + 1,
							x + 11 , y + 4,
							x + 8  , y + 4),
					yspeed = 70, xspeed = 0, shottimer = math.random(1,20)/10}
				end
			elseif chance > 49 and chance <= 75 then
				for num = 1, 16 do
					enemy[#enemy + 1] = {HC:addRectangle(math.random(0,280), 0, 20,20), yspeed = math.random(60,100), xspeed = math.random(-50,50)}
				end
			elseif chance > 75 and chance <= 100 then
				for num = 1, 8 do
					enemy[#enemy + 1] = {HC:addRectangle(40 + 25 * num, -10*num, 20,20), yspeed = 50, xspeed = 70, shottimer = math.random(1,20) / 10}
					enemy[#enemy + 1] = {HC:addRectangle(240 - 25 * num, -10*num, 20,20), yspeed = 50, xspeed = -70, shottimer = math.random(1,20) / 10}
				end
				powerups.ingame[#powerups.ingame + 1] = {HC:addRectangle(142,0,15,15), kind = powerups[math.random(1, #powerups)]}
			end
		end
	end
end

function love.draw()
	-- staarrrs
	love.graphics.setColor(125,125,125) --in their multitudes
	for num = 1, #stars do -- scarce to be coutned
		love.graphics.point(stars[num][1], round(stars[num][2]) +.5) -- filling the darkness
	end--with order and liiiiiiiiiiight
	-- powerups

	love.graphics.setScissor(0,0,300,554)
	for num = #powerups.ingame, 1 ,-1 do
		if powerups.ingame[num].kind.temporary == true then
			love.graphics.setColor(87,152,53)
		else
			love.graphics.setColor(24,47,124)
		end
		powerups.ingame[num][1]:draw("line")
		local x,y = powerups.ingame[num][1]:center()
		powerups.ingame[num].kind.graphic(x-7.5,y-7.5)
	end

	if bombexplode ~= nil then
		love.graphics.setColor(186,19,26)
		love.graphics.circle("line",bombexplode[1],bombexplode[2],bombexplode[3])
	end

	if fail ~= true and respawn == 0 then
		love.graphics.setColor(186,19,26)
		love.graphics.polygon("line",
			ship.xpos + ship.g[17][1], ship.ypos + ship.g[17][2],
			ship.xpos + ship.g[18][1], ship.ypos + ship.g[18][2] - jet,
			ship.xpos + ship.g[19][1], ship.ypos + ship.g[19][2] - jet,
			ship.xpos + ship.g[20][1], ship.ypos + ship.g[20][2])
		love.graphics.setColor(0,134,75)
		ship.col:draw("line")
		love.graphics.polygon("line",
			ship.xpos + ship.g[13][1], ship.ypos + ship.g[13][2],
			ship.xpos + ship.g[14][1], ship.ypos + ship.g[14][2],
			ship.xpos + ship.g[15][1], ship.ypos + ship.g[15][2],
			ship.xpos + ship.g[16][1], ship.ypos + ship.g[16][2])
		if ship.shield ~= nil then
			love.graphics.setColor(0,136,138)
			ship.shield:draw("line")
		end
	elseif fail == true then
		love.graphics.setColor(255,255,255)
		love.graphics.printf("GAME OVER", 0,296, 300, "center")
	end

	love.graphics.setColor(0,134,75)
	for num = 1, #bullets do
		bullets[num][1]:draw("line")
	end
	love.graphics.setColor(192,102,22)
	for num = #enemy, 1, -1 do
		enemy[num][1]:draw("line")
	end
	for num = #enemy.bullets, 1, -1 do
		enemy.bullets[num][1]:draw("line")
	end
	if boss ~= nil then
		boss.graphic()
		love.graphics.rectangle("line",0,0,(boss.health/boss.maxhealth)*300, 20)
		--love.graphics.printf(boss.health.."/"..boss.maxhealth,0,4,300,"center")
		for num = #boss.bullets, 1, -1 do
			boss.bullets[num][1]:draw("line")
		end
	end
	if bossexplode ~= nil then
		for num = #explodes, 1 ,-1 do
			love.graphics.circle("line",explodes[num][1],explodes[num][2],explodes[num][3])
		end
	end
	love.graphics.setScissor()

	--debugs
	love.graphics.setColor(255,255,255)
	love.graphics.line(0,555,300,555)
	love.graphics.print("SCORE: "..score,0,557)
	love.graphics.print("WAVE# "..waves,0,572)
	love.graphics.print("BOMBS: "..bombs,75,587)
	love.graphics.print("LIVES: "..lives,0,587)
	love.graphics.printf("Powerups",215, 557, 85, "center")
	for num = 1, 3 do
		love.graphics.rectangle("line", 300 - 25 * num,575, 15, 15)
		if ship.powerup[num] ~= nil then
			ship.powerup[num].graphic(300 - 25 * num, 575)
		end
		love.graphics.setColor(255,255,255)
	end
	if gamestate == "paused" then
		love.graphics.setFont(bigfont)
		love.graphics.printf("~PAUSED~",0,285,300, "center")
		love.graphics.setFont(norfont)
	elseif gamestate == "controllersetup" then
		love.graphics.setFont(bigfont)
		love.graphics.printf("Controller setup!\n"..
				controlsets[#setup +1]..":",0,285,300, "center")
		love.graphics.setFont(norfont)
	end
	-- title
	if waves == 0 then
		love.graphics.setFont(medfont)
		love.graphics.printf([[Made (almost) entirely by Thomas Harrison (copyright (c) 2013)

		LÖVE & HardonCollider copyright (c) their respective owners




		Control list:

		WASD: movement
		O: shoot
		P: bomb
		escape: pause

		Newest powerup is swapped with the oldest one]],0,90,300, "center")
		love.graphics.setFont(bigfont)
		love.graphics.printf("Vacuous",0,50,300,"center")
		love.graphics.setFont(norfont)
	end

	if waves == 9 then
		love.graphics.setFont(medfont)
		love.graphics.printf("Boss approaching!",0,50,300, "center")
	elseif waves == 10 and boss == nil then
		love.graphics.setFont(medfont)
		love.graphics.printf("Level 1 complete!",0,50,300, "center")
	elseif waves == 11 and boss == nil then
		love.graphics.setFont(medfont)
		love.graphics.printf("Level 2",0,50,300, "center")
	elseif waves == 19 then
		love.graphics.setFont(medfont)
		love.graphics.printf("Boss approaching!",0,50,300, "center")
	elseif waves == 20 and boss == nil then
		love.graphics.setFont(medfont)
		love.graphics.printf("Level 2 complete!",0,50,300, "center")
	elseif waves == 21 and boss == nil then
		love.graphics.setFont(medfont)
		love.graphics.printf("Level 3",0,50,300, "center")
	elseif waves == 29 then
		love.graphics.setFont(medfont)
		love.graphics.printf("Boss approaching!",0,50,300, "center")
	elseif waves == 30 and boss == nil then
		love.graphics.setFont(medfont)
		love.graphics.printf("Level 3 complete!",0,50,300, "center")
	elseif waves == 31 and boss == nil then
		love.graphics.setFont(medfont)
		love.graphics.printf("All levels complete! \n Sending random waves of enemies",0,50,300, "center")
	end
	love.graphics.setFont(norfont)
end

function love.focus(focus)
	if focus == false and gamestate ~= "paused" then
		gamestate = "paused"
	end
end

function round(num)
	return math.floor(num +.5)
end
